/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.66 Revision 1.87
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.66 2009/02/23 23:46:31 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.87 2012/04/18 16:52:30 hd_brummy Exp $
4
5# @ECLASS: vdr-plugin.eclass
6# @MAINTAINER:
7# vdr@gentoo.org
8# @BLURB: common vdr plugin ebuild functions
9# @DESCRIPTION:
10# Eclass for easing maitenance of vdr plugin ebuilds
11
12# Authors:
13# Matthias Schwarzott <zzam@gentoo.org>
14# Joerg Bornkessel <hd_brummy@gentoo.org>
15# Christian Ruppert <idl0r@gentoo.org>
16
17# Plugin config file installation:
4# 18#
5# Author: 19# A plugin config file can be specified through the $VDR_CONFD_FILE variable, it
6# Matthias Schwarzott <zzam@gentoo.org> 20# defaults to ${FILESDIR}/confd. Each config file will be installed as e.g.
7# Joerg Bornkessel <hd_brummy@gentoo.org> 21# ${D}/etc/conf.d/vdr.${VDRPLUGIN}
8 22
9# vdr-plugin.eclass 23# Installation of rc-addon files:
24# NOTE: rc-addon files must be valid shell scripts!
10# 25#
11# eclass to create ebuilds for vdr plugins 26# Installing rc-addon files is basically the same as for plugin config files
27# (see above), it's just using the $VDR_RCADDON_FILE variable instead.
28# The default value when $VDR_RCADDON_FILE is undefined is:
29# ${FILESDIR}/rc-addon.sh and will be installed as
30# ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
12# 31#
32# The rc-addon files will be sourced by the startscript when the specific plugin
33# has been enabled.
34# rc-addon files may be used to prepare everything that is necessary for the
35# plugin start/stop, like passing extra command line options and so on.
13 36
14# Example ebuild (vdr-femon): 37# Applying your own local/user patches:
38# This is done by using the epatch_user() function of the eutils.eclass.
39# Simply put your patches into one of these directories:
40# /etc/portage/patches/<CATEGORY>/<PF|P|PN>/
41# Quote: where the first of these three directories to exist will be the one to
42# use, ignoring any more general directories which might exist as well.
15# 43#
16# inherit vdr-plugin 44# For more details about it please take a look at the eutils.class.
17# IUSE=""
18# SLOT="0"
19# DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)"
20# HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/"
21# SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz"
22# LICENSE="GPL-2"
23# KEYWORDS="~x86"
24# DEPEND=">=media-video/vdr-1.3.27"
25#
26#
27
28# Installation of a config file for the plugin
29#
30# If ${VDR_CONFD_FILE} is set install this file
31# else install ${FILESDIR}/confd if it exists.
32
33# Gets installed as /etc/conf.d/vdr.${VDRPLUGIN}.
34# For the plugin vdr-femon this would be /etc/conf.d/vdr.femon
35
36
37# Installation of an rc-addon file for the plugin
38#
39# If ${VDR_RCADDON_FILE} is set install this file
40# else install ${FILESDIR}/rc-addon.sh if it exists.
41#
42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
43# (in example vdr-femon this would be /usr/share/vdr/rcscript/plugin-femon.sh)
44#
45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
46# It could be used for special startup actions for this plugins, or to create the
47# plugin command line options from a nicer version of a conf.d file.
48
49# HowTo use own local patches; Example
50#
51# Add to your /etc/make.conf:
52# VDR_LOCAL_PATCHES_DIR="/usr/local/patch"
53#
54# Add two DIR's in your local patch dir, ${PN}/${PV},
55# e.g for vdr-burn-0.1.0 should be:
56# /usr/local/patch/vdr-burn/0.1.0/
57#
58# all patches which ending on diff or patch in this DIR will automatically applied
59#
60 45
61inherit base multilib eutils flag-o-matic 46inherit base multilib eutils flag-o-matic
47
48if ! has "${EAPI:-0}" 0 1 2 3 4; then
49 die "API of vdr-plugin.eclass in EAPI=\"${EAPI}\" not established"
50fi
62 51
63IUSE="" 52IUSE=""
64 53
65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 54# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
66VDRPLUGIN="${PN/#vdrplugin-/}" 55VDRPLUGIN="${PN/#vdrplugin-/}"
74 63
75# depend on headers for DVB-driver 64# depend on headers for DVB-driver
76COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2" 65COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
77 66
78DEPEND="${COMMON_DEPEND} 67DEPEND="${COMMON_DEPEND}
79 media-tv/linuxtv-dvb-headers" 68 virtual/linuxtv-dvb-headers"
80RDEPEND="${COMMON_DEPEND} 69RDEPEND="${COMMON_DEPEND}
81 >=app-admin/eselect-vdr-0.0.2" 70 >=app-admin/eselect-vdr-0.0.2"
71
72# this is a hack for ebuilds like vdr-xineliboutput that want to
73# conditionally install a vdr-plugin
74if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]]; then
75 # make DEPEND conditional
76 IUSE="${IUSE} vdr"
77 DEPEND="vdr? ( ${DEPEND} )"
78 RDEPEND="vdr? ( ${RDEPEND} )"
79fi
82 80
83# New method of storing plugindb 81# New method of storing plugindb
84# Called from src_install 82# Called from src_install
85# file maintained by normal portage-methods 83# file maintained by normal portage-methods
86create_plugindb_file() { 84create_plugindb_file() {
154 done 152 done
155} 153}
156 154
157fix_vdr_libsi_include() 155fix_vdr_libsi_include()
158{ 156{
159 einfo "Fixing include of libsi-headers" 157 #einfo "Fixing include of libsi-headers"
160 local f 158 local f
161 for f; do 159 for f; do
162 sed -i "${f}" \ 160 sed -i "${f}" \
163 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \ 161 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
164 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:' 162 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
184 # To satisfy 1-3 we do this: 182 # To satisfy 1-3 we do this:
185 # Set VDRDIR=/usr/include/vdr 183 # Set VDRDIR=/usr/include/vdr
186 # Set VDRINCDIR=/usr/include 184 # Set VDRINCDIR=/usr/include
187 # Change $(VDRDIR)/include to $(VDRINCDIR) 185 # Change $(VDRDIR)/include to $(VDRINCDIR)
188 186
189 ebegin " Setting paths"
190 sed -i Makefile \ 187 sed -i Makefile \
191 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \ 188 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
192 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \ 189 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
193 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \ 190 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
194 \ 191 \
195 -e 's:-I$(DVBDIR)/include::' \ 192 -e 's:-I$(DVBDIR)/include::' \
196 -e 's:-I$(DVBDIR)::' 193 -e 's:-I$(DVBDIR)::'
197 eend 0
198 194
199 # maybe needed for multiproto: 195 # maybe needed for multiproto:
200 #sed -i Makefile \ 196 #sed -i Makefile \
201 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 197 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
202 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' 198 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
218 214
219 # Disabling file stripping, useful for debugging 215 # Disabling file stripping, useful for debugging
220 sed -i Makefile \ 216 sed -i Makefile \
221 -e '/@.*strip/d' \ 217 -e '/@.*strip/d' \
222 -e '/strip \$(LIBDIR)\/\$@/d' \ 218 -e '/strip \$(LIBDIR)\/\$@/d' \
223 -e '/@.*\$(STRIP)/d' 219 -e 's/STRIP.*=.*$/STRIP = true/'
224 220
225 # Use a file instead of a variable as single-stepping via ebuild 221 # Use a file instead of a variable as single-stepping via ebuild
226 # destroys environment. 222 # destroys environment.
227 touch "${WORKDIR}"/.vdr-plugin_makefile_patched 223 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
228} 224}
229 225
230vdr_add_local_patch() {
231 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
232 echo
233 einfo "Applying local patches"
234 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
235 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
236 done
237 fi
238}
239
240vdr_has_gettext() { 226vdr_has_gettext() {
241 has_version ">=media-video/vdr-1.5.7" 227 has_version ">=media-video/vdr-1.5.7"
242} 228}
243 229
244plugin_has_gettext() { 230plugin_has_gettext() {
245 [[ -d po ]] 231 [[ -d po ]]
232 # some plugins gives false positive results, keep this list short
233 # temporary workout, ToDo: fix the plugins/eclass
234 has_version ">=media-plugins/vdr-streamdev-0.5.0"
235 has_version ">=media-plugins/vdr-vdrmanager-0.6"
246} 236}
247 237
248vdr_i18n_convert_to_gettext() { 238vdr_i18n_convert_to_gettext() {
239 if has_version ">=media-video/vdr-1.7.22"; then
240 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext"
241 else
249 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl" 242 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
243 fi
250 244
251 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then 245 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
252 ewarn "Conversion to gettext disabled in ebuild" 246 ewarn "Conversion to gettext disabled in ebuild"
253 return 1 247 return 1
254 fi 248 fi
284 return 1 278 return 1
285 fi 279 fi
286} 280}
287 281
288vdr_i18n_disable_gettext() { 282vdr_i18n_disable_gettext() {
289 ebegin "Disabling gettext support in plugin" 283 #einfo "Disabling gettext support in plugin"
284
290 # Remove i18n Target if using older vdr 285 # Remove i18n Target if using older vdr
291 sed -i Makefile \ 286 sed -i Makefile \
292 -e '/^all:/s/ i18n//' 287 -e '/^all:/s/ i18n//'
293 eend 0
294} 288}
295 289
296vdr_i18n() { 290vdr_i18n() {
297 if vdr_has_gettext; then 291 if vdr_has_gettext; then
298 einfo "VDR has gettext support" 292 #einfo "VDR has gettext support"
299 if plugin_has_gettext; then 293 if plugin_has_gettext; then
300 einfo "Plugin has gettext support, fine" 294 #einfo "Plugin has gettext support, fine"
301 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then 295 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
302 ewarn "Please remove left over NO_GETTEXT_HACK." 296 ewarn "Please remove unneeded NO_GETTEXT_HACK from ebuild."
303 fi 297 fi
304 else 298 else
305 vdr_i18n_convert_to_gettext 299 vdr_i18n_convert_to_gettext
306 if [[ $? != 0 ]]; then 300 if [[ $? != 0 ]]; then
307 eerror ""
308 eerror "Plugin will have only english OSD texts" 301 einfo "Plugin has no OSD texts or will have only english OSD texts"
309 eerror "it needs manual fixing."
310 fi 302 fi
311 fi 303 fi
312 else 304 else
313 einfo "VDR has no gettext support" 305 #einfo "VDR has no gettext support"
314 if plugin_has_gettext; then 306 if plugin_has_gettext; then
315 vdr_i18n_disable_gettext 307 vdr_i18n_disable_gettext
316 fi 308 fi
317 fi 309 fi
318} 310}
355 elog "To activate a plugin execute this command:" 347 elog "To activate a plugin execute this command:"
356 elog "\teselect vdr-plugin enable <plugin_name> ..." 348 elog "\teselect vdr-plugin enable <plugin_name> ..."
357 elog 349 elog
358} 350}
359 351
352has_vdr() {
353 [[ -f "${VDR_INCLUDE_DIR}"/config.h ]]
354}
360 355
361## exported functions 356## exported functions
362 357
363vdr-plugin_pkg_setup() { 358vdr-plugin_pkg_setup() {
364 # -fPIC is needed for shared objects on some platforms (amd64 and others) 359 # -fPIC is needed for shared objects on some platforms (amd64 and others)
365 append-flags -fPIC 360 append-flags -fPIC
366 361
362 # Plugins need to be compiled with position independent code, otherwise linking
363 # VDR against it will fail
364 if has_version ">=media-video/vdr-1.7.13"; then
365 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
366 fi
367
367 # Where should the plugins live in the filesystem 368 # Where should the plugins live in the filesystem
368 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins" 369 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
369 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums" 370 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
370 371
371 # was /usr/lib/... some time ago 372 # was /usr/lib/... some time ago
375 # Pathes to includes 376 # Pathes to includes
376 VDR_INCLUDE_DIR="/usr/include/vdr" 377 VDR_INCLUDE_DIR="/usr/include/vdr"
377 DVB_INCLUDE_DIR="/usr/include" 378 DVB_INCLUDE_DIR="/usr/include"
378 379
379 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale" 380 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
380 LOCDIR="/usr/share/vdr/locale" 381 LOCDIR="/usr/share/locale"
382
383 if ! has_vdr; then
384 # set to invalid values to detect abuses
385 VDRVERSION="eclass_no_vdr_installed"
386 APIVERSION="eclass_no_vdr_installed"
387
388 if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]] && ! use vdr; then
389 einfo "VDR not found!"
390 else
391 # if vdr is required
392 die "VDR not found!"
393 fi
394 return
395 fi
381 396
382 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 397 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
383 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 398 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
384 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 399 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
385 400
386 einfo "Compiling against" 401 einfo "Compiling against"
387 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]" 402 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
403
404
405 if [ -n "${VDR_LOCAL_PATCHES_DIR}" ]; then
406 eerror "Using VDR_LOCAL_PATCHES_DIR is deprecated!"
407 eerror "Please move all your patches into"
408 eerror "${EROOT}/etc/portage/patches/${CATEGORY}/${P}"
409 eerror "and remove or unset the VDR_LOCAL_PATCHES_DIR variable."
410 die
411 fi
388} 412}
389 413
390vdr-plugin_src_util() { 414vdr-plugin_src_util() {
391
392 while [ "$1" ]; do 415 while [ "$1" ]; do
393
394 case "$1" in 416 case "$1" in
395 all) 417 all)
396 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n 418 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
397 ;; 419 ;;
398 all_but_unpack) 420 prepare|all_but_unpack)
399 vdr-plugin_src_util add_local_patch patchmakefile i18n 421 vdr-plugin_src_util add_local_patch patchmakefile i18n
400 ;; 422 ;;
401 unpack) 423 unpack)
402 base_src_unpack 424 base_src_unpack
403 ;; 425 ;;
404 add_local_patch) 426 add_local_patch)
405 cd "${S}" || die "Could not change to plugin-source-directory!" 427 cd "${S}" || die "Could not change to plugin-source-directory!"
406 vdr_add_local_patch 428 epatch_user
407 ;; 429 ;;
408 patchmakefile) 430 patchmakefile)
409 cd "${S}" || die "Could not change to plugin-source-directory!" 431 cd "${S}" || die "Could not change to plugin-source-directory!"
410 vdr_patchmakefile 432 vdr_patchmakefile
411 ;; 433 ;;
412 i18n) 434 i18n)
435 # i18n-to-gettext tool removed starting with version 1.7.27
436 if has_version "<media-video/vdr-1.7.27"; then
413 cd "${S}" || die "Could not change to plugin-source-directory!" 437 cd "${S}" || die "Could not change to plugin-source-directory!"
414 vdr_i18n 438 vdr_i18n
439 fi
415 ;; 440 ;;
416 esac 441 esac
417 442
418 shift 443 shift
419 done 444 done
427 eerror "Please report this at bugs.gentoo.org." 452 eerror "Please report this at bugs.gentoo.org."
428 die "vdr-plugin_pkg_setup not called!" 453 die "vdr-plugin_pkg_setup not called!"
429 fi 454 fi
430 if [ -z "$1" ]; then 455 if [ -z "$1" ]; then
431 case "${EAPI:-0}" in 456 case "${EAPI:-0}" in
432 2) 457 2|3|4)
433 vdr-plugin_src_util unpack 458 vdr-plugin_src_util unpack
434 ;; 459 ;;
435 *) 460 *)
436 vdr-plugin_src_util all 461 vdr-plugin_src_util all
437 ;; 462 ;;
441 vdr-plugin_src_util $@ 466 vdr-plugin_src_util $@
442 fi 467 fi
443} 468}
444 469
445vdr-plugin_src_prepare() { 470vdr-plugin_src_prepare() {
446 vdr-plugin_src_util all_but_unpack 471 base_src_prepare
472 vdr-plugin_src_util prepare
447} 473}
448 474
449vdr-plugin_src_compile() { 475vdr-plugin_src_compile() {
450 [ -z "$1" ] && vdr-plugin_src_compile prepare compile 476 [ -z "$1" ] && vdr-plugin_src_compile copy_source compile
451 477
452 while [ "$1" ]; do 478 while [ "$1" ]; do
453 479
454 case "$1" in 480 case "$1" in
455 prepare) 481 copy_source)
456 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 482 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
457 ;; 483 ;;
458 compile) 484 compile)
459 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then 485 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
460 eerror "Wrong use of vdr-plugin.eclass." 486 eerror "Wrong use of vdr-plugin.eclass."
564vdr-plugin_pkg_postrm() { 590vdr-plugin_pkg_postrm() {
565 delete_orphan_plugindb_file 591 delete_orphan_plugindb_file
566} 592}
567 593
568vdr-plugin_pkg_config() { 594vdr-plugin_pkg_config() {
569 ewarn "emerge --config ${PN} is no longer supported" 595:
570 vdr-plugin_print_enable_command
571} 596}
572 597
573case "${EAPI:-0}" in 598case "${EAPI:-0}" in
574 2) 599 2|3|4)
575 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config 600 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
576 ;; 601 ;;
577 *) 602 *)
578 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 603 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
579 ;; 604 ;;

Legend:
Removed from v.1.66  
changed lines
  Added in v.1.87

  ViewVC Help
Powered by ViewVC 1.1.20